org.apache.bcel.classfile

## Class PMGClass

- java.lang.Object
- - org.apache.bcel.classfile.Attribute
  - - org.apache.bcel.classfile.PMGClass

- All Implemented Interfaces:
    Cloneable, Node

      public final class PMGClass
      extends Attribute

  This class is derived from Attribute and represents a reference to a PMG attribute.
  See Also:
    `Attribute`

- - ### Field Summary

    - ### Fields inherited from class org.apache.bcel.classfile.Attribute

      `constant_pool, EMPTY_ARRAY, length, name_index, tag`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PMGClass(int nameIndex, int length, int pmgIndex, int pmgClassIndex, ConstantPool constantPool)`
    `PMGClass(PMGClass pgmClass)` Initialize from another object.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(Visitor v)` Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
    `Attribute` | `copy(ConstantPool constantPool)`
    `void` | `dump(DataOutputStream file)` Dump source file attribute to file stream in binary format.
    `int` | `getPMGClassIndex()`
    `String` | `getPMGClassName()`
    `int` | `getPMGIndex()`
    `String` | `getPMGName()`
    `void` | `setPMGClassIndex(int pmgClassIndex)`
    `void` | `setPMGIndex(int pmgIndex)`
    `String` | `toString()`

    - ### Methods inherited from class org.apache.bcel.classfile.Attribute

      `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getName, getNameIndex, getTag, println, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### PMGClass

          public PMGClass(int nameIndex,
                          int length,
                          int pmgIndex,
                          int pmgClassIndex,
                          ConstantPool constantPool)

      Parameters:
        `nameIndex` - Index in constant pool to CONSTANT_Utf8
        `length` - Content length in bytes
        `pmgIndex` - index in constant pool for source file name
        `pmgClassIndex` - Index in constant pool to CONSTANT_Utf8
        `constantPool` - Array of constants

    - #### PMGClass

          public PMGClass(PMGClass pgmClass)

      Initialize from another object. Note that both objects use the same references (shallow copy). Use copy() for a physical copy.

  - ### Method Detail

    - #### accept

          public void accept(Visitor v)

      Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
      Specified by:
        `accept` in interface `Node`
      Specified by:
        `accept` in class `Attribute`
      Parameters:
        `v` - Visitor object

    - #### copy

          public Attribute copy(ConstantPool constantPool)

      Specified by:
        `copy` in class `Attribute`
      Returns:
        deep copy of this attribute

    - #### dump

          public void dump(DataOutputStream file)
                    throws IOException

      Dump source file attribute to file stream in binary format.
      Overrides:
        `dump` in class `Attribute`
      Parameters:
        `file` - Output file stream
      Throws:
        `IOException` - if an I/O error occurs.

    - #### getPMGClassIndex

          public int getPMGClassIndex()

      Returns:
        Index in constant pool of source file name.

    - #### getPMGClassName

          public String getPMGClassName()

      Returns:
        PMG class name.

    - #### getPMGIndex

          public int getPMGIndex()

      Returns:
        Index in constant pool of source file name.

    - #### getPMGName

          public String getPMGName()

      Returns:
        PMG name.

    - #### setPMGClassIndex

          public void setPMGClassIndex(int pmgClassIndex)

      Parameters:
        `pmgClassIndex` -

    - #### setPMGIndex

          public void setPMGIndex(int pmgIndex)

      Parameters:
        `pmgIndex` -

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Attribute`
      Returns:
        String representation

Copyright © 2004–2022 The Apache Software Foundation. All rights reserved.